var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import React, { useState } from 'react';
import { Button, Checkbox, Form, FormGroup, Panel, PanelMain, PanelMainBody, Text, TextArea, TextContent, TextVariants, } from '@patternfly/react-core';
import { LocaleContext } from '../context/LocaleContext';
import '../Feedback/Feedback.css';
export const FeedbackForm = ({ email, onCloseModal, onSubmit, onClickBack, handleFeedbackError, modalTitle, modalDescription, textareaLabel, feedbackType, checkboxDescription, textAreaHidden = false, submitTitle, }) => {
    const intl = React.useContext(LocaleContext);
    const [textAreaValue, setTextAreaValue] = useState('');
    const [checked, setChecked] = useState(false);
    function handleModalSubmission() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                onSubmit();
            }
            catch (err) {
                handleFeedbackError();
            }
        });
    }
    return (React.createElement("div", { className: "chr-c-feedback-content" },
        React.createElement(TextContent, null,
            React.createElement(Text, { component: TextVariants.h1 }, modalTitle),
            modalDescription),
        React.createElement(Form, null,
            textAreaHidden ? ('') : (React.createElement(FormGroup, { label: textareaLabel, fieldId: "horizontal-form-exp" },
                React.createElement(TextArea, { value: textAreaValue, onChange: (value) => setTextAreaValue(value), className: "chr-c-feedback-text-area", name: "feedback-description-text", id: "feedback-description-text" }))),
            React.createElement(FormGroup, { className: "pf-u-mt-20" },
                React.createElement(Checkbox, { id: "feedback-checkbox", isChecked: checked, onChange: () => setChecked(!checked), label: intl.researchOpportunities, description: checkboxDescription }))),
        checked ? (React.createElement(React.Fragment, null,
            React.createElement("div", { className: "pf-u-font-family-heading-sans-serif chr-c-feedback-email" }, intl.email),
            React.createElement(Panel, { variant: "raised", className: "chr-c-feedback-panel" },
                React.createElement(PanelMain, null,
                    React.createElement(PanelMainBody, { className: "chr-c-feedback-panel__body" }, email))))) : (''),
        React.createElement("div", { className: "chr-c-feedback-buttons" },
            React.createElement(Button, { ouiaId: "submit-feedback", className: "chr-c-feedback-footer-button", key: "confirm", variant: "primary", 
                // eslint-disable-next-line no-nested-ternary
                isDisabled: feedbackType !== '[Research Opportunities]' ? (textAreaValue.length > 1 ? false : true) : !checked, onClick: handleModalSubmission }, submitTitle),
            React.createElement(Button, { ouiaId: "back-feedback", className: "chr-c-feedback-footer-button", key: "back", variant: "secondary", onClick: onClickBack }, intl.back),
            React.createElement(Button, { ouiaId: "cancel-feedback", className: "chr-c-feedback-footer-button", key: "cancel", variant: "link", onClick: onCloseModal }, intl.cancel))));
};
